'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _linkButton = require('./styles/linkButton');

var _linkButton2 = _interopRequireDefault(_linkButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created with WebStorm.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * User: gp
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Date: 16-2-24
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var LinkButton = function (_Component) {
    _inherits(LinkButton, _Component);

    /**
     * props有： title,icon,color,  iconStyle, hide
     *
     *
     *
     * @param props
     * @param context
     */
    function LinkButton(props, context) {
        _classCallCheck(this, LinkButton);

        var _this = _possibleConstructorReturn(this, (LinkButton.__proto__ || Object.getPrototypeOf(LinkButton)).call(this, props, context));

        _this.state = _this._buildStates(props);
        return _this;
    }

    _createClass(LinkButton, [{
        key: 'render',
        value: function render() {
            var props = this.props;
            var theme = this._processTheme(props);
            var events = {
                onMouseDown: this._onMouseDown.bind(this),
                onMouseUp: this._onMouseUp.bind(this)
            };
            if (!props.disabled) {
                events.onClick = this._onClick.bind(this);
            }

            return _react2.default.createElement(
                'a',
                _extends({ className: 'link', style: theme.link }, events),
                props.icon && _react2.default.createElement('i', { className: 'icon', style: this.state.icon }),
                _react2.default.createElement(
                    'span',
                    { className: 'icon-title', style: { color: this.state.color } },
                    this.state.title
                )
            );
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            this.state = this._buildStates(props);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this._timer) {
                clearTimeout(this._timer);
            }
        }

        /**
         * 通过state控制的只有标题、颜色、图标，来处理按下和恢复时按钮样式
         * @return {{title: (*|string), icon: *, color: (*|$color)}}
         * @private
         */

    }, {
        key: '_buildStates',
        value: function _buildStates(props) {
            var theme = this._processTheme(props);
            var tics = this._warpArray(props, 'title', 'color', 'icon');
            var title = tics.title[0] || '',
                icon = theme.icon,
                color = tics.color[0] || theme.color;
            if (tics.icon[0]) {
                Object.assign(theme.icon, { backgroundImage: 'url(' + tics.icon[0] + ')' });
            }
            if (props.disabled) {
                title = tics.title[2] || title;
                color = tics.color[2] || color;
                if (tics.icon[2]) {
                    Object.assign(theme.icon, { backgroundImage: 'url(' + tics.icon[2] + ')' });
                }
            } else {
                if (tics.icon[0]) {
                    Object.assign(theme.icon, { backgroundImage: 'url(' + tics.icon[0] + ')' });
                }
            }

            var obj = {
                title: title,
                icon: icon,
                color: color
            };

            return obj;
        }
    }, {
        key: '_processTheme',
        value: function _processTheme(props) {
            var theme = this.theme = (0, _linkButton2.default)();
            var _props$iconStyle = props.iconStyle;
            var iconStyle = _props$iconStyle === undefined ? {} : _props$iconStyle;
            var _props$hide = props.hide;
            var hide = _props$hide === undefined ? false : _props$hide;

            Object.assign(theme.icon, iconStyle);
            theme.link.display = hide ? 'none' : '-webkit-flex';
            if (props.disabled) {
                theme.link.pointerEvents = 'none';
                theme.link.opacity = 0.55;
            }
            return theme;
        }

        //将字符串对象包装成一个数组对象

    }, {
        key: '_warpArray',
        value: function _warpArray(obj) {
            var _str2arr = this._str2arr;
            var map = {};

            for (var _len = arguments.length, keys = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                keys[_key - 1] = arguments[_key];
            }

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var key = _step.value;

                    map[key] = _str2arr(obj[key]);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return map;
        }
    }, {
        key: '_str2arr',
        value: function _str2arr(val) {
            if (val == undefined) {
                return [];
            } else if (!Array.isArray(val)) {
                return [val];
            } else {
                return val;
            }
        }
    }, {
        key: '_onMouseDown',
        value: function _onMouseDown() {
            var tics = this._warpArray(this.props, 'title', 'color', 'icon');
            var theme = this.theme;
            var state = {
                title: tics.title[1] || tics.title[0] || '',
                icon: Object.assign({}, theme.icon, { backgroundImage: 'url(' + (tics.icon[1] || tics.icon[0] || '') + ')' }),
                color: tics.color[1] || tics.color[0] || theme.color
            };
            this.setState(state);
            return state;
        }
    }, {
        key: '_onMouseUp',
        value: function _onMouseUp() {
            var _this2 = this;

            var tics = this._warpArray(this.props, 'title', 'color', 'icon');
            var theme = this.theme;
            var state = {
                title: tics.title[0],
                icon: Object.assign({}, theme.icon, { backgroundImage: 'url(' + (tics.icon[0] || '') + ')' }),
                color: tics.color[0] || theme.blue
            };
            this._timer = setTimeout(function () {
                _this2.setState(state);
                _this2._timer = null;
            });
            return state;
        }
    }, {
        key: '_onClick',
        value: function _onClick() {
            var _props = this.props;
            var onClick = _props.onClick;
            var scope = _props.scope;


            if (onClick) {
                onClick.apply(scope);
            }
        }
    }]);

    return LinkButton;
}(_react.Component);

exports.default = LinkButton;