
var path = require('path');
var webpack = require('webpack');
var HtmlWebpackPlugin = require('html-webpack-plugin');
var ExtractTextPlugin = require("extract-text-webpack-plugin");
var cssLoaders = 'style-loader!css-loader!postcss-loader';
//var cssLoaders = ExtractTextPlugin.extract('style-loader','css-loader!postcss-loader');

module.exports = {
    entry:"./demo/src/js/app.js",
    output:{
        path:"./demo/dist",
        filename:"bundle.js"
    },
    plugins:[
        new webpack.HotModuleReplacementPlugin(), //hot loading
        new HtmlWebpackPlugin({
            template: 'demo/index.html',
            inject: true
        })
    ],
    module: {
        loaders:[
            {
                test: /\.js$/,
                loader: 'babel',
                exclude: path.join('./','/node_modules/'),
                query:
                {
                    presets:['react']
                }
            },
            {
                test:   /\.css$/,
                loader: cssLoaders
            }
        ]
    }
};